# Changelog

releases_release_uri = "https://github.com/dorianpula/rookeries/releases/%s"
releases_issue_uri = "https://bitbucket.org/dorianpula/rookeries/issues/%s"

* :release:`0.15.0 <2019-08-23>`
* :feature:`0` Migrate Rookeries away from a CMS to a static site generator.
* :feature:`0` Add support for starting a new Rookeries project.
* :feature:`0` Add support for serving and building a Rookeries project.
* :feature:`0` Add support for analytics plugins.
* :feature:`0` Add dark-mode-switch plugin to support light and dark reading modes.
* :feature:`0` Release as a deb package for Ubuntu and Debian.
* :support:`0` Refactor template to work with static site generation.
* :support:`0` Refactor main web component as the `rookeries-app` web component.
* :support:`0` Remove the legacy `rookeries-link` plugin.
* :support:`0` Remove the admin console and dependencies to focus Rookeries as
a CLI static site generator.

* :release:`0.14.1 <2019-06-14>`
* :feature:`0` Significantly reduce the size of the Rookeries container.
* :support:`0` Add support to test plugins.
* :support:`0` Switch over to a parallelized workflow CI setup.

* :release:`0.14.0 <2019-05-15>`
* :feature:`0` Create plugin architecture to allow for frontend plugins.
* :feature:`0` Introduce `hello-world` and `rookeries-links` plugins.

* :release:`0.13.1 <2019-04-25>`
* :support:`0` Improve future development by separating web-app from server components.
* :bug:`0` Fix layout issues with missing elements.
* :support:`0` Remove unused JS libraries.
* :support:`0` Track the latest stable version of Rust.

* :release:`0.13.0 <2018-11-30>`
* :support:`0` Migrate Rookeries to use Postgres.
* :support:`0` Add in migrations for Postgres.

* :release:`0.12.1 <2018-08-23>`
* :bug:`0` Fix issue with theme switch breaking background colour on article component.
* :support:`0` Upgrade Rust and JS dependencies.

* :release:`0.12.0 <2018-08-21>`
* :support:`0` Migrate off Python completely.  Just pure Rust + Javascript.
* :bug:`0` Fix issue with UI frontend not displaying the landing page.

* :release:`0.11.0 <2018-08-15>`
* :support:`0` Migrate integration tests to Rust.

* :release:`0.10.0 <2018-08-09>`
* :support:`0` Port Python REST API to Rust as part of project re-work.

* :release:`0.9.0 <2017-12-05>`
* :feature:`0` Add saving modified site.
* :feature:`0` Add editing of menu including addition and removal of menu items.
* :feature:`0` Add editing of site, header and footer blocks.
* :feature:`0` Add ability to choose pre-determined blocks.
* :feature:`0` Migrate to using MobX over redux.
* :support:`0` Migrate away from reactstrap to use plain old html components and some bootstrap CSS.
* :feature:`0` Add support to secure CouchDB installation by requiring a user.
* :support:`0` Usability improvements to the administrative invoke tasks.

* :release:`0.7.0 <2017-10-26>`
* :support:`0` Transition to using CouchDB instead of PostgreSQL for ease of use.
* :support:`0` Use the newer pipenv to manage Python dependencies.
* :feature:`0` Start transition to using sidebar for administrating sites.
* :support:`0` Fix issues with live code editing.

* :release:`0.6.3 <2017-09-06>`
* :feature:`30` Add some support for modifying the site and blocks of content.
* :support:`0` Transition to locally running Selenium nodes for UI "web" tests.
* :support:`0` Migrate to using the newer CircleCI 2.0 build system.
* :feature:`38` Re-architecture Rookeries into a single container application to simplify deployment.
* :feature:`37` Add support for database migrations using Alembic and Flask-Alembic.
* :bug:`35` Resolve crash caused by posting to `/api/user/` with an existing user's username.
* :support:`36` Change workflow to publish new Docker images to Docker Hub via CircleCI.

* :release:`0.6.1 <2017-03-07>`
* :support:`0` Release to properly show the git revisions in the status endpoint.
* :support:`34` Add git revision to the status endpoint to enable easier tracking.

* :release:`0.6.0 <2017-03-07>`
* :support:`34` Add git revision to the status endpoint to enable easier tracking.
* :feature:`27` Add support to create, modify and delete users with different roles.
* :support:`0` Develop the top-level concepts for Rookeries.
* :support:`32` Upgrade API to use latest stable versions of Python 3.6.
* :feature:`30` Link pages to individual sites.
* :support:`0` Convert rote build infrastructure to use simpler Makefile and scripts setup.
* :support:`28` Make invoke the main entry point for everything in the API server.
* :bug:`24` Enable upgrade to the latest version of Flask, by fixing the way exception handlers are registered.
* :support:`29` Enforce API keys to receiving content from API server.
* :support:`29` Migrate site configurations and menus to the database.
* :support:`26` Switch over from CouchDB 1.6 to PostgreSQL 9.6.
* :support:`17` Upgrade API to use latest stable versions of Python 3.5.
* :support:`17` Add in dumb-init for better control of starting services.

* :release:`0.5.0 <2016-11-05>`
* :support:`0` Upgrade to use latest stable versions of Node 6.9.
* :support:`25` Improve logging in Rookeries API.
* :support:`23` Allow for setting of admin credentials via environment variables.
* :support:`22` Dockerize Rookeries API and webapp to allow for easier development and deployment.
* :support:`22` Break up Rookeries into separate webapp and api, to allow for server-side rendering.
* :feature:`6` Add CouchDB persistance of content.
* :support:`0` Simplify layout of Rookeries into something simpler to showcase the new focus of the application.
* :support:`0` Major rework for application and code clean-up.
* :support:`0` Transition to using React as frontend tech.
* :support:`0` Addition of proper testing infrastructure.

* :release:`0.4.9 <2015-07-13>`
* :feature:`0` Separate frontend and deployment scripts into standalone projects.  See `rookeries-react-app
  <https://bitbucket.org/dorianpula/rookeries-react-app>`_ and `ansible-rookeries
  <https://bitbucket.org/dorianpula/ansible-rookeries>`_.
* :support:`0` Simplify and update Python requirements.
* :support:`0` Make codebase :pep:`8` compliant.
* :support:`0` Add tasks for testing with nose and coverage.
* :support:`0` Add Sphinx documentation.
* :bug:`0` Migrate administrative functionality into separate invoke tasks.

* :release:`0.3.0 <2013-07-25>`
* :support:`0` Started using enums for some constrainted model values using
  `enum34 <https://pypi.python.org/pypi/enum34>`_ and
  `SQLAlchemy's Enums <http://techspot.zzzeek.org/2011/01/14/the-enum-recipe/>`_. [2013 June 28]
* :feature:`0` Built out user account management and registration. [2013 June 30]
* :support:`0` Added `special JSON string responses for Flask  <http://flask.pocoo.org/snippets/83/>`_ [2013 July 03]
* :feature:`0` Added switchable CSS themes. [2013 July 04]
* :support:`0` Transitioned to `LESS <http://lesscss.org/>`_ to simplify CSS with mixins, using colour hues,
  et cetera. [2013 July 08]
* :support:`0` Start task and project sub-project.
* :feature:`0` Added in AngularJS frontend driven by JSON responses.

* :release:`0.2.0 <2013-06-25>`
* :support:`0` Transitioned documentation to reStructured text. [2013 May 09]
* :feature:`0` Migrated static reStructured text pages to Markdown.
* :feature:`0` Reorganized webapp into a modular structure.

* :release:`0.1.0 <2013-04-24>`
* :feature:`0` Initial release of rookeries.
