/*
Hello world example plugin

@copyright (c) Copyright 2019 Dorian Pula
@license Apache-2.0
@author Dorian Pula [dorian.pula@amber-penguin-software.ca]
*/

class HelloWorld extends HTMLElement {
  static get observedAttributes() {
    return ["name"];
  }

  static get tagName() {
    return "hello-world"
  }

  connectedCallback() {
    const name = this.getAttribute("name") || "World";
    this.innerHTML = `<p>Hello, ${name}</p>`;
  }

}

if (customElements.get(HelloWorld.tagName) === undefined) {
  customElements.define(HelloWorld.tagName, HelloWorld);
}
