/* global describe it expect */

import "../src/plugin";


describe("The hello-world element", () => {

  it("should be defined as custom element", () => {
    expect(customElements.get("hello-world")).not.to.eq(undefined);
  });

  it("render with a default name", () => {
    const testElement = document.createElement("hello-world");
    document.body.appendChild(testElement);

    const expectedInnerHtml = `<p>Hello, World</p>`;
    expect(testElement.innerHTML).to.eq(expectedInnerHtml);
  });

  it("render with a specified name", () => {
    const testElement = document.createElement("hello-world");
    testElement.setAttribute("name", "friend");
    document.body.appendChild(testElement);

    const expectedInnerHtml = `<p>Hello, friend</p>`;
    expect(testElement.innerHTML).to.eq(expectedInnerHtml);
  });
});
