# Rookeries

**Rookeries** is:
 
- A developer and designer friendly static site generator for building gorgeous, 
maintainable and extendable websites, that embraces the future of the web.
- Powered by Rust and Web Components.
- Licensed under the Apache 2.0 license.

## Build Status:

- [![Built with cargo-make](https://sagiegurari.github.io/cargo-make/assets/badges/cargo-make.svg)](https://sagiegurari.github.io/cargo-make)
- **CircleCI**: [![CircleCI](https://circleci.com/bb/dorianpula/rookeries.svg?style=svg)](https://circleci.com/bb/dorianpula/rookeries "CircleCI builds")


## Development

*Rookeries* uses the following technologies:

- Rust 2018 (1.36+)
- Node 10.x

Note that *Rookeries* is heavily under active development and may undergo 
significant changes before its 1.0.0 release.

### Getting Started

1. Clone the repository.
1. Install [cargo-make](https://sagiegurari.github.io/cargo-make): `cargo install --force cargo-make`
1. Build Rookeries: `cargo build`
1. Run UI tests: `cargo make test-app`
1. Run tests: `cargo make test`
1. Create and run the sample site:
    1. `cargo make init-sample-site`
    1. `cargo make build-sample-site`
    1. `cargo make serve-sample-site`
