# Demo

## Markdown + HTML5 Templates

Rookeries takes Markdown, passes it through HTML5 templates, and creates
a modern site.  Rookeries supports the [CommonMark spec for Markdown][1]
and GFM extensions for strike-through text and tables.  It can render elements 
such as:

- Ordered and unordered lists
- Tables
- Strike-through text
- Code + quote blocks
- Links
- Images
- Embedded HTML
- Horizontal Rules

[1]: https://spec.commonmark.org/0.18/

___

Markdown Source:
```markdown
Rookeries takes Markdown, passes it through HTML5 templates, and creates
a modern site.  Rookeries supports the [CommonMark spec for Markdown][1]
and GFM extensions for strike-through text and tables.  It can render elements 
such as:

- Ordered and unordered lists
- Tables
- Strike-through text
- Code + quote blocks
- Links
- Images
- Embedded HTML
- Horizontal Rules

[1]: https://spec.commonmark.org/0.18/

___
```

## Links

Internal links use a HTML5 router to avoid full page refreshes, while external 
links behave as you would expect.  Both HTML and Markdown links are supported:

* [Internal Inline Markdown Link](/demo)
* <a href="/demo">Internal HTML Link</a>
* [Internal Referenced Markdown Link][2]
* [Internal Homepage Link](/)
* [External Homepage Link](https://rookeries.org/)

[2]: /demo

## Plugins

With the appropriate plugins you can extend the functionality of Rookeries.  A
few plugins can be seen below. 


| Plugin | Code | Result |
| -- | -- | -- |
| hello-world | `<hello-world name = "reader" />` | <hello-world name = "reader" /> |
| dark-mode-switch | `<dark-mode-switch theme="dark" />` | <dark-mode-switch theme="dark" /> |


## Code Highlighting

Rookeries also can handle syntax highlighting:

```rust
/// Gets the application version.
fn get_app_version() -> String {
    // Yes, this is a demo.
    format!(
        "rookeries v{version} © 2013-2019 {authors}",
        version = env!("CARGO_PKG_VERSION"),
        authors = env!("CARGO_PKG_AUTHORS"),
    )
    .to_string()
}
```
